(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["@xterm-stack/client-react"] = factory();
	else
		root["@xterm-stack/client-react"] = factory();
})(typeof self !== 'undefined' ? self : this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 10);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("react-apollo");

/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("@xterm-stack/client-redux");

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const client_theme_redux_1 = __webpack_require__(7);
const Icons = __webpack_require__(14);
const defaultTerminalColors = {
    light: {
        background: '#FFF',
        foreground: '#333',
        finderInputBorder: 'windowtext',
    },
    dark: {
        background: '#1b1b1b',
        foreground: '#CCC',
        inputBackground: '#3C3C3C',
        finderInputBorder: '#0E639C',
    },
    hc: {
        background: '#000',
        foreground: '#FFF',
        finderInputBorder: '#0E639C',
    },
};
exports.getColors = (theme) => {
    const background = client_theme_redux_1.getThemeSetting(theme.name, 'terminal.background', defaultTerminalColors[theme.name].background);
    const foreground = client_theme_redux_1.getThemeSetting(theme.name, 'terminal.foreground', defaultTerminalColors[theme.name].foreground);
    const inputBackground = client_theme_redux_1.getThemeSetting(theme.name, 'terminal.inputBackground', defaultTerminalColors[theme.name].inputBackground);
    const colors = {
        background,
        foreground,
    };
    return colors;
};
exports.getTerminalColor = (theme, colors) => {
    let themeName = theme ? theme.name : null;
    let color = colors && themeName ? colors[themeName] : '';
    return color;
};
const getKillActionStyle = (theme) => {
    if (theme.name === 'hc' || theme.name === 'dark') {
        return { background: `url("data:image/svg+xml;charset=utf-8,${Icons.actionKillInverse}") center center no-repeat` };
    }
    else {
        return { background: `url("data:image/svg+xml;charset=utf-8,${Icons.actionKill}") center center no-repeat` };
    }
};
const getNewActionStyle = (theme) => {
    if (theme.name === 'hc' || theme.name === 'dark') {
        return { background: `url("data:image/svg+xml;charset=utf-8,${Icons.actionNewInverse}") center center no-repeat` };
    }
    else {
        return { background: `url("data:image/svg+xml;charset=utf-8,${Icons.actionNew}") center center no-repeat` };
    }
};
exports.getActionStyle = (theme, action) => {
    if (action === 'new') {
        return getNewActionStyle(theme);
    }
    else if (action === 'kill') {
        return getKillActionStyle(theme);
    }
    else {
        return null;
    }
};
exports.getFindColor = (theme) => {
    const background = client_theme_redux_1.getThemeSetting(theme.name, 'terminal.background', defaultTerminalColors[theme.name].background);
    const styles = {
        backgroundColor: background,
    };
    return styles;
};
exports.getFindInputColor = (theme) => {
    const border = client_theme_redux_1.getThemeSetting(theme.name, 'terminal.finder.input.border', defaultTerminalColors[theme.name].finderInputBorder);
    const styles = {
        borderColor: border,
    };
    return styles;
};
exports.getFindActionColors = (theme) => {
    if (theme.name === 'hc' || theme.name === 'dark') {
        return {
            '&.previous': { background: `url("data:image/svg+xml;charset=utf-8,${Icons.actionPreviousInverse}") center center no-repeat` },
            '&.next': { background: `url("data:image/svg+xml;charset=utf-8,${Icons.actionNextInverse}") center center no-repeat` },
            '&.closer': { background: `url("data:image/svg+xml;charset=utf-8,${Icons.actionCloseDark}") center center no-repeat` },
        };
    }
    else {
        return {
            '&.previous': { background: `url("data:image/svg+xml;charset=utf-8,${Icons.actionPrevious}") center center no-repeat` },
            '&.next': { background: `url("data:image/svg+xml;charset=utf-8,${Icons.actionNext}") center center no-repeat` },
            '&.closer': { background: `url("data:image/svg+xml;charset=utf-8,${Icons.actionClose}") center center no-repeat` },
        };
    }
};


/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = require("react");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("@xterm-stack/graphql-gql");

/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("react-redux");

/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = require("react-fela");

/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/client-theme-redux");

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(15));
__export(__webpack_require__(22));
var xterm_header_1 = __webpack_require__(23);
exports.XtermHeaderComponent = xterm_header_1.default;


/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = require("classnames");

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var xterm_1 = __webpack_require__(11);
exports.Xterm = xterm_1.default;
var xterm_header_1 = __webpack_require__(25);
exports.XtermHeader = xterm_header_1.default;


/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(5);
const react_fela_1 = __webpack_require__(6);
const react_apollo_1 = __webpack_require__(0);
const client_layout_redux_1 = __webpack_require__(12);
const client_modal_redux_1 = __webpack_require__(13);
const client_redux_1 = __webpack_require__(1);
const colors_1 = __webpack_require__(2);
const components_1 = __webpack_require__(8);
const mapStateToProps = (state) => ({
    color: state.terminalColor,
    terminalTheme: state.terminalTheme,
    terminalAction: state.terminalAction,
    height: state.resize.consolePanel,
    left: state.resize.treePanel,
});
const mapDispatchToProps = (dispatch) => ({
    resetCommand: () => {
        dispatch(client_redux_1.resetCommand());
    },
    resizePanel: (height) => {
        dispatch(client_layout_redux_1.resize('consolePanel', height));
    },
    setError: (error, type) => {
        dispatch(client_modal_redux_1.setError(error, type));
    },
    sendingText: () => {
        dispatch(client_redux_1.sendingText());
    },
});
exports.default = react_apollo_1.compose(...[
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
    react_fela_1.connect({
        container: ({ theme }) => (Object.assign({ 'align-content': 'flex-start', 'align-items': 'baseline', display: 'flex', 'flex-direction': 'column', height: 'calc(100% - 0px)', width: '100%', padding: '0 20px', position: 'relative' }, colors_1.getColors(theme))),
        terminalContainer: ({ theme, color }) => ({
            height: '100%',
            width: '100%',
            '& .xterm': {
                backgroundColor: 'transparent !important',
                height: '100%',
            },
            '& .xterm-viewport': {
                right: '-20px',
                '&::-webkit-scrollbar': {
                    width: '10px',
                },
                '&::-webkit-scrollbar-track': {
                    opacity: 0,
                },
                '&::-webkit-scrollbar-thumb': {
                    backgroundColor: 'rgba(100, 100, 100, .5)',
                    '&:hover': {
                        transition: 'opacity 0ms linear',
                        backgroundColor: 'rgba(100, 100, 100, .7)',
                    },
                    '&:window-inactive': {
                        backgroundColor: 'inherit',
                    },
                },
            },
        }),
        finder: ({ theme }) => (Object.assign({ position: 'absolute', display: 'flex', top: 0, right: '2px', height: '30px', overflow: 'hidden', lineHeight: '19px', padding: '4px', zIndex: 10, transition: 'top 200ms linear', boxShadow: '0px 1px 8px rgba(0,0,0,0.8)' }, colors_1.getFindColor(theme), { '>input': Object.assign({ fontSize: '13px', backgroundColor: 'transparent', outline: 'none', width: '120px', borderStyle: 'solid', borderWidth: '1px' }, colors_1.getFindInputColor(theme)), '>span': Object.assign({ width: '20px', height: '20px', display: 'inline-block', verticalAlign: 'middle', marginLeft: '3px', cursor: 'pointer' }, colors_1.getFindActionColors(theme)) })),
    }),
])(react_fela_1.withTheme(components_1.withXtermData(components_1.XtermComponent)));


/***/ }),
/* 12 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/client-layout-redux");

/***/ }),
/* 13 */
/***/ (function(module, exports) {

module.exports = require("@workbench-stack/client-modal-redux");

/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.actionKill = `%3Csvg version='1.1' id='Layer_1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' viewBox='0 0 16 16' style='enable-background:new 0 0 16 16;' xml:space='preserve'%3E%3Cpath fill='#424242' d='M10,3V2c0-0.6-0.4-1-1-1H6C5.4,1,5,1.4,5,2v1H2v1h1v10c0,0.6,0.4,1,1,1h7c0.6,0,1-0.4,1-1V4h1V3H10z M6,12H5V6 h1V12z M6,2h3v1H6V2z M8,12H7V6h1V12z M10,12H9V6h1V12z'/%3E%3C/svg%3E`;
exports.actionKillInverse = `%3Csvg version='1.1' id='Layer_1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' viewBox='0 0 16 16' style='enable-background:new 0 0 16 16;' xml:space='preserve'%3E%3Cpath fill='#C5C5C5' d='M10,3V2c0-0.6-0.4-1-1-1H6C5.4,1,5,1.4,5,2v1H2v1h1v10c0,0.6,0.4,1,1,1h7c0.6,0,1-0.4,1-1V4h1V3H10z M6,12H5V6 h1V12z M6,2h3v1H6V2z M8,12H7V6h1V12z M10,12H9V6h1V12z'/%3E%3C/svg%3E`;
exports.actionNew = `%3Csvg version='1.1' id='Layer_1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' viewBox='0 0 16 16' style='enable-background:new 0 0 16 16;' xml:space='preserve'%3E%3Crect x='7' y='3' fill='#424242' width='3' height='11'/%3E%3Crect x='3' y='7' fill='#424242' width='11' height='3'/%3E%3C/svg%3E`;
exports.actionNewInverse = `%3Csvg version='1.1' id='Layer_1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' viewBox='0 0 16 16' style='enable-background:new 0 0 16 16;' xml:space='preserve'%3E%3Crect x='7' y='3' fill='#C5C5C5' width='3' height='11'/%3E%3Crect x='3' y='7' fill='#C5C5C5' width='11' height='3'/%3E%3C/svg%3E`;
exports.actionClose = `%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='3 3 16 16' enable-background='new 3 3 16 16'%3E%3Cpolygon fill='#424242' points='12.597,11.042 15.4,13.845 13.844,15.4 11.042,12.598 8.239,15.4 6.683,13.845 9.485,11.042 6.683,8.239 8.238,6.683 11.042,9.486 13.845,6.683 15.4,8.239'/%3E%3C/svg%3E`;
exports.actionCloseDark = `%3Csvg xmlns='http://www.w3.org/2000/svg' width='16' height='16' viewBox='3 3 16 16' enable-background='new 3 3 16 16'%3E%3Cpolygon fill='#e8e8e8' points='12.597,11.042 15.4,13.845 13.844,15.4 11.042,12.598 8.239,15.4 6.683,13.845 9.485,11.042 6.683,8.239 8.238,6.683 11.042,9.486 13.845,6.683 15.4,8.239'/%3E%3C/svg%3E`;
exports.actionNext = `%3Csvg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' width='16px' height='16px' viewBox='-1 -3 16 16' enable-background='new -1 -3 16 16' xml:space='preserve'%3E%3Cpath fill='#424242' d='M1,4h7L5,1h3l4,4L8,9H5l3-3H1V4z'/%3E%3C/svg%3E`;
exports.actionNextInverse = `%3Csvg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' width='16px' height='16px' viewBox='-1 -3 16 16' enable-background='new -1 -3 16 16' xml:space='preserve'%3E%3Cpath fill='#C5C5C5' d='M1,4h7L5,1h3l4,4L8,9H5l3-3H1V4z'/%3E%3C/svg%3E`;
exports.actionPrevious = `%3Csvg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' width='16px' height='16px' viewBox='-1 -3 16 16' enable-background='new -1 -3 16 16' xml:space='preserve'%3E%3Cpolygon fill='#424242' points='13,4 6,4 9,1 6,1 2,5 6,9 9,9 6,6 13,6 '/%3E%3C/svg%3E`;
exports.actionPreviousInverse = `%3Csvg version='1.1' xmlns='http://www.w3.org/2000/svg' xmlns:xlink='http://www.w3.org/1999/xlink' x='0px' y='0px' width='16px' height='16px' viewBox='-1 -3 16 16' enable-background='new -1 -3 16 16' xml:space='preserve'%3E%3Cpolygon fill='#C5C5C5' points='13,4 6,4 9,1 6,1 2,5 6,9 9,9 6,6 13,6 '/%3E%3C/svg%3E`;


/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(3);
const xterm_1 = __webpack_require__(16);
const cx = __webpack_require__(9);
const fit = __webpack_require__(17);
const search = __webpack_require__(18);
const webLink = __webpack_require__(19);
const graphql_gql_1 = __webpack_require__(4);
const xterm_finder_1 = __webpack_require__(20);
__webpack_require__(21);
const colors_1 = __webpack_require__(2);
const __ENTER_KEY_CODE__ = 13;
const __BACKSPACE_KEY_CODE__ = 8;
class XtermComponent extends React.Component {
    constructor(props, context) {
        super(props, context);
        this.onKeyDown = (event) => {
            let charCode = String.fromCharCode(event.which).toLowerCase();
            if (event.ctrlKey && charCode === 'f' || event.metaKey && charCode === 'f') {
                event.preventDefault();
                this.setState({ finding: true });
            }
        };
        this.fit = () => {
            return new Promise((resolve) => {
                window.setTimeout(() => {
                    if (this.xterm) {
                        let geometry = this.xterm.proposeGeometry();
                        if (geometry) {
                            this.xterm.resize(geometry.cols, geometry.rows);
                        }
                    }
                    resolve();
                }, 100);
            });
        };
        this.searchPrevious = (text) => this.xterm.findPrevious(text);
        this.searchNext = (text) => this.xterm.findNext(text);
        this.state = {
            isFocused: false,
            creating: false,
            finding: false,
            waitingActiveInstance: false,
        };
        this.buffer = '';
    }
    async componentDidMount() {
        const xtermInstance = this.getXtermInstance();
        const options = {
            cursorBlink: false,
            allowTransparency: true,
            theme: this.getTheme(),
        };
        this.xterm = new xtermInstance(options);
        this.xterm.on('data', this.onData.bind(this));
        this.xterm.on('resize', this.onResize.bind(this));
        this.xterm.open(this.containerRef);
        this.xterm.focus();
        window.onresize = this.fit;
        this.fit().then(() => {
            if (this.props.terminalBuffer) {
                this.writeBuffer(this.props.activeInstance, this.props.terminalBuffer);
            }
        });
    }
    componentWillReceiveProps(nextProps) {
        const { loadingTerminalInstances, terminalInstances, activeInstance, terminalBuffer, terminalAction } = nextProps;
        const { terminalBuffer: prevTerminalBuffer, terminalAction: prevTerminalAction } = this.props;
        if (!loadingTerminalInstances && terminalInstances && !terminalInstances.length) {
            if (!this.state.creating) {
                this.setState({ creating: true });
                this.createInstance();
            }
        }
        else if (activeInstance && terminalBuffer && (!prevTerminalBuffer || terminalBuffer.id !== prevTerminalBuffer.id)) {
            this.writeBuffer(activeInstance, terminalBuffer);
            if (!this.unsubscribe || this.state.waitingActiveInstance) {
                this.subscribeTerminalData(activeInstance.id);
                this.setState({ waitingActiveInstance: false });
            }
        }
        if (terminalAction && !prevTerminalAction) {
            this.processAction(terminalAction);
        }
    }
    componentDidUpdate(prevProps, prevState) {
        const { height, left, theme, color } = this.props;
        if (this.xterm) {
            if (prevProps.height !== height || prevProps.left !== left) {
                this.fit();
            }
            if (prevProps.theme !== theme || prevProps.color !== color) {
                this.setTheme();
            }
        }
    }
    componentWillUnmount() {
        if (this.props.terminalBuffer) {
            this.props.saveTerminalBuffer({
                id: this.props.terminalBuffer.id,
                buffer: this.buffer,
            });
        }
        if (this.xterm) {
            this.xterm.destroy();
            this.xterm = null;
        }
    }
    getTheme() {
        const { theme, color } = this.props;
        const themeColors = colors_1.getColors(theme);
        if (color) {
            const foreground = colors_1.getTerminalColor(theme, color);
            if (foreground) {
                themeColors['foreground'] = foreground;
            }
        }
        return themeColors;
    }
    setTheme() {
        this.xterm.setOption('theme', this.getTheme());
    }
    getXtermInstance() {
        if (!this.xtermInstance) {
            xterm_1.Terminal.applyAddon(search);
            xterm_1.Terminal.applyAddon(fit);
            xterm_1.Terminal.applyAddon(webLink);
            this.xtermInstance = xterm_1.Terminal;
        }
        return this.xtermInstance;
    }
    processAction(terminalAction) {
        if (terminalAction.command === 'create-instance') {
            this.createInstance().then(() => {
                this.props.resetCommand();
            });
        }
        else if (terminalAction.command === 'activate-instance') {
            this.setActiveInstance(terminalAction.instance).then(() => {
                this.props.resetCommand();
            });
        }
        else if (terminalAction.command === 'delete-instance') {
            this.deleteInstance();
        }
    }
    subscribeTerminalData(instanceId) {
        this.unsubscribe = this.props.subscribeTerminalData({
            document: graphql_gql_1.TERMINAL_DATA_SUBSCRIPTION,
            variables: { id: instanceId },
            updateQuery: ({ getActiveInstance: prevActiveInstance }, { subscriptionData }) => {
                const terminalData = subscriptionData.data.terminalData;
                if (instanceId === terminalData.id) {
                    let message = terminalData.msg;
                    if (this.xterm) {
                        this.xterm.write(message);
                    }
                    this.buffer += message;
                }
            },
            onError: (error) => {
                this.props.setError(error.message, 'error');
            },
        });
    }
    createInstance() {
        const { terminalInstances } = this.props;
        let config = {};
        let count = terminalInstances && terminalInstances.length || 0;
        const shellConfig = {};
        let geometry = this.xterm.proposeGeometry();
        if (geometry) {
            const dimension = {
                width: geometry.cols,
                height: geometry.rows,
            };
            config = {
                shell: shellConfig,
                dimension,
            };
        }
        else {
            config = {
                shell: shellConfig,
            };
        }
        return this.props.createInstance(config)
            .then(({ data: { createInstance: newInstance } }) => {
            this.setState({ creating: false });
            this.props.refetchTerminalInstances();
            this.setActiveInstance(newInstance);
        })
            .catch((error) => {
            this.props.setError(error.message, 'error');
            this.setState({ creating: false });
        });
    }
    setActiveInstance(instance) {
        const { activeInstance } = this.props;
        if (activeInstance) {
            this.props.saveTerminalBuffer({
                id: activeInstance.id,
                buffer: this.buffer,
            });
        }
        return this.props.setActiveInstance({ terminalInstance: { id: instance.id, processId: instance.processId } })
            .then(({ data: { setActiveInstance: newActiveInstance } }) => {
            this.props.refetchActiveInstance();
            if (this.unsubscribe) {
                this.unsubscribe();
            }
            this.setState({ waitingActiveInstance: true });
            this.xterm.showCursor();
        })
            .catch((error) => {
            this.props.setError(error.message, 'error');
        });
    }
    deleteInstance() {
        const { terminalInstances, activeInstance } = this.props;
        if (terminalInstances.length && activeInstance) {
            this.props.saveTerminalBuffer({
                id: activeInstance.id,
                buffer: '',
            });
            return this.props.deleteInstance({ id: activeInstance.id })
                .then(({ data: { deleteInstance: result } }) => {
                this.props.refetchTerminalInstances();
                this.props.refetchActiveInstance();
                if (this.unsubscribe) {
                    this.unsubscribe();
                }
                this.props.resetCommand();
                this.setState({ waitingActiveInstance: true });
                if (terminalInstances.length === 1) {
                    this.props.resizePanel(0);
                }
            })
                .catch((error) => {
                this.props.setError(error.message, 'error');
            });
        }
    }
    onResize({ cols, rows }) {
        if (this.props.activeInstance) {
            this.props.setInstanceSize({ id: this.props.activeInstance.id, dimension: { width: cols, height: rows } })
                .then((data) => { })
                .catch((error) => {
                this.props.setError(error.message, 'error');
            });
        }
    }
    async onData(text) {
        if (!this.props.activeInstance) {
            return;
        }
        else {
            try {
                await this.props.sendText({ id: this.props.activeInstance.id, text, addNewLine: false });
            }
            catch (error) {
                this.props.setError(error.message, 'error');
            }
        }
    }
    onInput(key, ev) {
        const printable = !ev.altKey && !ev.altGraphKey && !ev.ctrlKey && !ev.metaKey;
        if (ev.keyCode === __ENTER_KEY_CODE__) {
            if (this.props.terminalInstances && this.props.terminalInstances.length) {
                this.xterm.writeln('');
                this.props.sendText({ id: this.props.activeInstance.id, text: key, addNewLine: false })
                    .then((data) => {
                })
                    .catch((error) => {
                    this.props.setError(error.message, 'error');
                });
            }
        }
        else if (ev.keyCode === __BACKSPACE_KEY_CODE__) {
        }
        else if (printable) {
            this.xterm.write(key);
        }
    }
    writeBuffer(activeInstance, terminalBuffer) {
        if (activeInstance && terminalBuffer && terminalBuffer.id === activeInstance.id) {
            this.buffer = terminalBuffer.buffer || '';
            this.xterm.reset();
            if (this.buffer !== '') {
                this.xterm.write(this.buffer);
            }
            this.xterm.showCursor();
        }
    }
    focusChanged(focused) {
        this.setState({
            isFocused: focused,
        });
        this.props.onFocusChange && this.props.onFocusChange(focused);
    }
    render() {
        let { value, color, terminalTheme, styles } = this.props;
        const terminalClassName = cx('terminal-container', styles.terminalContainer);
        if (value) {
        }
        return (React.createElement("div", { className: cx('react-terminal', styles.container), onKeyDown: this.onKeyDown },
            this.state.finding ?
                React.createElement(xterm_finder_1.default, { className: styles.finder, onFindNext: this.searchNext, onFindPrevious: this.searchPrevious, onClose: () => this.setState({ finding: false }) })
                : null,
            React.createElement("div", { ref: r => this.containerRef = r, className: terminalClassName })));
    }
}
exports.XtermComponent = XtermComponent;


/***/ }),
/* 16 */
/***/ (function(module, exports) {

module.exports = require("xterm");

/***/ }),
/* 17 */
/***/ (function(module, exports) {

module.exports = require("xterm/lib/addons/fit/fit");

/***/ }),
/* 18 */
/***/ (function(module, exports) {

module.exports = require("xterm/lib/addons/search/search");

/***/ }),
/* 19 */
/***/ (function(module, exports) {

module.exports = require("xterm/lib/addons/webLinks/webLinks");

/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const React = __webpack_require__(3);
const __ENTER_KEY_CODE__ = 13;
class XtermFinder extends React.Component {
    constructor(props, context) {
        super(props, context);
        this.handleText = (e) => {
            this.setState({ text: e.target.value });
        };
        this.handleFindNext = (e) => {
            this.props.onFindNext(this.state.text);
        };
        this.handleFindPrev = (e) => {
            this.props.onFindPrevious(this.state.text);
        };
        this.handleKeyDown = (e) => {
            if (e.keyCode === __ENTER_KEY_CODE__) {
                e.preventDefault();
                this.handleFindNext(e);
            }
        };
        this.handleClose = (e) => {
            this.props.onClose();
        };
        this.state = {
            text: '',
        };
    }
    render() {
        const { className } = this.props;
        return (React.createElement("div", { className: className },
            React.createElement("input", { type: "text", onKeyDown: this.handleKeyDown, onChange: this.handleText }),
            React.createElement("span", { className: "previous", onClick: this.handleFindPrev }),
            React.createElement("span", { className: "next", onClick: this.handleFindNext }),
            React.createElement("span", { className: "closer", onClick: this.handleClose })));
    }
}
exports.default = XtermFinder;


/***/ }),
/* 21 */
/***/ (function(module, exports) {

// removed by extract-text-webpack-plugin

/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_apollo_1 = __webpack_require__(0);
const graphql_gql_1 = __webpack_require__(4);
exports.withXtermData = react_apollo_1.compose(react_apollo_1.graphql(graphql_gql_1.TERMINAL_INSTANCES_QUERY, {
    props: ({ data: { loading, error, terminalInstances, refetch } }) => ({
        loadingTerminalInstances: loading,
        error,
        terminalInstances,
        refetchTerminalInstances: refetch,
    }),
}), react_apollo_1.graphql(graphql_gql_1.GET_ACTIVE_INSTANCE_QUERY, {
    props: ({ data: { getActiveInstance, subscribeToMore, refetch, loading } }) => ({
        loadingActiveInstance: loading,
        activeInstance: getActiveInstance,
        subscribeTerminalData: subscribeToMore,
        refetchActiveInstance: refetch,
    }),
}), react_apollo_1.graphql(graphql_gql_1.TERMINAL_BUFFER_QUERY, {
    skip: ({ activeInstance }) => !activeInstance,
    options: ({ activeInstance }) => ({ variables: { id: activeInstance.id } }),
    props: ({ ownProps: { activeInstance }, data: { terminalBuffer } }) => ({
        terminalBuffer: terminalBuffer && terminalBuffer.id === -1 ? Object.assign({}, terminalBuffer, { id: activeInstance.id }) : terminalBuffer,
    }),
}), react_apollo_1.graphql(graphql_gql_1.CREATE_INSTANCE_MUTATION, {
    props: ({ mutate }) => ({
        createInstance: (variables) => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_gql_1.SEND_TEXT_MUTATION, {
    options: {
        context: { debounceKey: 'xterm-send-text' },
    },
    props: ({ mutate }) => ({
        sendText: (variables) => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_gql_1.SET_ACTIVE_INSTANCE_MUTATION, {
    props: ({ mutate }) => ({
        setActiveInstance: (variables) => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_gql_1.SET_INSTANCE_SIZE_MUTATION, {
    props: ({ mutate }) => ({
        setInstanceSize: (variables) => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_gql_1.DELETE_INSTANCE_MUTATION, {
    props: ({ mutate }) => ({
        deleteInstance: (variables) => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_gql_1.SET_INSTANCE_SIZE_MUTATION, {
    props: ({ mutate }) => ({
        setInstanceSize: (variables) => mutate({ variables }),
    }),
}), react_apollo_1.graphql(graphql_gql_1.SAVE_TERMINAL_BUFFER_MUTATION, {
    props: ({ mutate }) => ({
        saveTerminalBuffer: (variables) => mutate({ variables }),
    }),
}));


/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const R = __webpack_require__(24);
const React = __webpack_require__(3);
const cx = __webpack_require__(9);
const client_redux_1 = __webpack_require__(1);
class XtermHeaderComponent extends React.Component {
    constructor(props) {
        super(props);
        this.handleActiveInstance = (e) => {
            const { terminalInstances, activeInstance } = this.props;
            const instanceId = e.target.value;
            const selectedInstance = R.find(R.propEq('id', parseInt(instanceId, 10)))(terminalInstances);
            if (selectedInstance !== undefined) {
                this.props.activateInstance(selectedInstance);
            }
            this.setState({ instanceId });
        };
        this.handleColor = (e) => {
            const selectedColor = R.find(R.propEq('name', e.target.value))(client_redux_1.colors);
            this.props.setColor(selectedColor);
        };
        this.state = {
            instanceId: '',
        };
    }
    componentDidMount() {
        this.props.loadColor();
    }
    componentWillReceiveProps(nextProps) {
        const { loading, activeInstance } = nextProps;
        if (!loading && activeInstance) {
            this.setState({ instanceId: activeInstance.id });
        }
    }
    handleAction(action) {
        if (action === 'new') {
            this.props.createInstance();
        }
        else if (action === 'kill') {
            this.props.deleteInstance();
        }
    }
    render() {
        const { terminalInstances, activeInstance, color, styles } = this.props;
        let colorName = color ? color.name : '';
        return (React.createElement("div", { className: styles.container },
            React.createElement("div", { className: "colors" },
                React.createElement("select", { className: styles.select, value: colorName, onChange: this.handleColor }, client_redux_1.colors && client_redux_1.colors.map((item, i) => (React.createElement("option", { key: i, value: item.name }, item.name))))),
            React.createElement("div", { className: "instances" },
                React.createElement("select", { className: styles.select, value: this.state.instanceId, onChange: this.handleActiveInstance }, terminalInstances && terminalInstances.map((instance, i) => (React.createElement("option", { key: i, value: instance.id }, `${i + 1}: ${instance.title}`))))),
            React.createElement("div", { className: cx('actions', styles.actions) },
                React.createElement("div", { className: cx(styles.action, styles.actionNew), onClick: (e) => this.handleAction('new') }),
                terminalInstances && terminalInstances.length ?
                    React.createElement("div", { className: cx(styles.action, styles.actionKill), onClick: (e) => this.handleAction('kill') })
                    : null)));
    }
}
exports.default = XtermHeaderComponent;


/***/ }),
/* 24 */
/***/ (function(module, exports) {

module.exports = require("ramda");

/***/ }),
/* 25 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const react_redux_1 = __webpack_require__(5);
const react_fela_1 = __webpack_require__(6);
const client_redux_1 = __webpack_require__(1);
const react_apollo_1 = __webpack_require__(0);
const graphql_gql_1 = __webpack_require__(4);
const components_1 = __webpack_require__(8);
const client_theme_redux_1 = __webpack_require__(7);
const colors_1 = __webpack_require__(2);
const withXtermHeaderData = react_apollo_1.compose(react_apollo_1.graphql(graphql_gql_1.TERMINAL_INSTANCES_QUERY, {
    props: ({ data: { loading, error, terminalInstances } }) => ({
        loading,
        error,
        terminalInstances,
    }),
}), react_apollo_1.graphql(graphql_gql_1.GET_ACTIVE_INSTANCE_QUERY, {
    props: ({ data: { getActiveInstance } }) => ({
        activeInstance: getActiveInstance,
    }),
}));
const mapStateToProps = (state, props) => ({
    color: state.terminalColor,
});
const mapDispatchToProps = (dispatch) => ({
    loadColor: () => {
        dispatch(client_redux_1.loadColor());
    },
    setColor: (color) => {
        dispatch(client_redux_1.setColor(color));
    },
    createInstance: () => {
        dispatch(client_redux_1.createInstance());
    },
    activateInstance: (instance) => {
        dispatch(client_redux_1.activateInstance(instance));
    },
    deleteInstance: () => {
        dispatch(client_redux_1.deleteInstance());
    },
});
exports.default = react_apollo_1.compose(...[
    react_redux_1.connect(mapStateToProps, mapDispatchToProps),
    react_fela_1.connect({
        container: () => ({
            display: 'flex',
            'justify-content': 'space-between',
            padding: '6px 0px',
            fontSize: '11px',
            '> div': {
                display: 'flex',
                'justify-content': 'flex-end',
            },
        }),
        actions: () => ({
            display: 'flex',
            'justify-content': 'space-around',
        }),
        action: () => ({
            display: 'inline-block',
            cursor: 'pointer',
            width: '32px',
            height: '20px',
            padding: '0 10px',
        }),
        actionNew: ({ theme }) => colors_1.getActionStyle(theme, 'new'),
        actionKill: ({ theme }) => colors_1.getActionStyle(theme, 'kill'),
        select: ({ theme }) => (Object.assign({ marginRight: '20px', minWidth: '100px', height: '22px', outline: 'none' }, client_theme_redux_1.getSelectColor(theme))),
    }),
])(react_fela_1.withTheme(withXtermHeaderData(components_1.XtermHeaderComponent)));


/***/ })
/******/ ]);
});
//# sourceMappingURL=index.js.map